<?php
/**
* Файл проверки языковых файлов
* 
* @author Igor Ognichenko
* @copyright Copyright (c)2007-2009 by Kasseler CMS
* @link http://www.kasseler-cms.net/
* @filesource language_check.php
* @version 2.0
*/

define('KASSELERCMS', true);

require_once "base.php";
require_once "includes/function/xining.php";
require_once "includes/function/init.php";
require_once "includes/nocache.php";

global $main;
$correct_lang = (!isset($_GET['lang'])) ? 'russian' : $_GET['lang'];
$text = "<div class='warnmsg' style='color: #2C8CD0;' align='center'>[ <a href='language_check.php' title='Количество ключей в файлах'>Количество ключей в файлах</a> | <a href='language_check.php?op=keys' title='Найти недостающие ключи'>Найти недостающие ключи</a> | <a href='language_check.php?op=duplicate' title='Найти дубликаты ключей'>Найти дубликаты ключей</a> ]</div>";
$languages = $dup_arr = array();

$path = 'includes/language/';
if($handle = kr_opendir($path)) {
    while(false !== ($file = readdir($handle))) if($file!='.' AND $file!='..' AND $file!='.svn' AND $file!=$correct_lang AND kr_is_dir($path.$file)) $languages[] = $file;
    closedir($handle);
}

$correct_files = array();
if($handle = kr_opendir('includes/language/'.$correct_lang)){
    while(false !== ($file = readdir($handle))){
        if(preg_match('/(.+?)\.php$/i', $file)){
            $file_name = preg_replace('/(.+?)\.php$/i', '\\1', $file);
            preg_match('/\s=\sarray\((.*)\);/is', kr_get_content("includes/language/{$correct_lang}/{$file}"), $match);
            $r = explode("\n", $match[1]);
            $_lang = array();
            foreach($r as $row){
                $_arr = explode('=>', $row);
                if(count($_arr)<2) continue;
                $key = trim($_arr[0]); $key = substr($key, 1, strlen($key)); $key = substr($key, 0, strlen($key)-1);
                $value = trim($_arr[1]); $value = substr($value, 1, strlen($value)); $value = substr($value, 0, strlen($value)-1); $value = ($value[strlen($value)-1]=="'") ? substr($value, 0, strlen($value)-1) : $value;
                if(!isset($_lang[$key])) $_lang[$key] = htmlspecialchars(stripslashes($value));
                else $dup_arr[$file_name][] = $key;
            }                            
            $correct_files[$file_name] = $_lang;
        }
    }
}     

if(!isset($_GET['op'])){
    $text .= "<h2>Количество ключей в файлах</h2><div class='warnmsg'>";
    foreach($languages as $lang_dir){
        $text .= "<span style='color: #2C8CD0;'><b>".(isset($main->lang[$lang_dir])?$main->lang[$lang_dir]:$lang_dir)."</b></span><br />"; 
        $path = "includes/language/{$lang_dir}/";
        if($handle = kr_opendir($path)){
            while(false !== ($file = readdir($handle))){
                if(preg_match('/(.+?)\.php$/i', $file)){
                    $file_name = preg_replace('/(.+?)\.php$/i', '\\1', $file);
                    preg_match('/\s=\sarray\((.*)\);/is', kr_get_content("includes/language/{$lang_dir}/{$file}"), $match);            
                    $r = explode("\n", $match[1]);
                    $_lang = array();
                    foreach($r as $row){
                        $_arr = explode('=>', $row);
                        if(count($_arr)<2) continue;
                        $key = trim($_arr[0]); $key = substr($key, 1, strlen($key)); $key = substr($key, 0, strlen($key)-1);
                        $value = trim($_arr[1]); $value = substr($value, 1, strlen($value)); $value = substr($value, 0, strlen($value)-1); $value = ($value[strlen($value)-1]=="'") ? substr($value, 0, strlen($value)-1) : $value;
                        $_lang[$key] = htmlspecialchars(stripslashes($value));
                    }
                    $c1 = isset($correct_files[$file_name]) ? count($correct_files[$file_name]) : 0;  
                    $c2 = count($_lang);  
                    $text .= "<pre><span style='color: #333333;'><b>{$correct_lang}</b> {$file_name}     \t".($c1<$c2?"<font style='color: #EF5959;'>{$c1}</font>":"<font style='color: #6CCF4D;'>{$c1}</font>")."    \t<b>{$lang_dir}</b> {$file_name}     \t".($c1>$c2?"<font style='color: #EF5959;'>{$c2}</font>":"<font style='color: #6CCF4D;'>{$c2}</font>")."</span></pre>";                
                }
            }
        }
        $text .= "<hr />";
    }
    $text .= "</div>";
} elseif($_GET['op']=='keys'){
    $text .= "<h2>Поиск недостающих ключей</h2>";
    foreach($languages as $lang_dir){        
        $text .= "<div class='warnmsg'>";
        $path = "includes/language/{$lang_dir}/";
        if($handle = kr_opendir($path)){
            while(false !== ($file = readdir($handle))){
                if(preg_match('/(.+?)\.php$/i', $file)){
                    $file_name = preg_replace('/(.+?)\.php$/i', '\\1', $file);
                    preg_match('/\s=\sarray\((.*)\);/is', kr_get_content("includes/language/{$lang_dir}/{$file}"), $match);            
                    $r = explode("\n", $match[1]);
                    $_lang = array();
                    foreach($r as $row){
                        $_arr = explode('=>', $row);
                        if(count($_arr)<2) continue;
                        $key = trim($_arr[0]); $key = substr($key, 1, strlen($key)); $key = substr($key, 0, strlen($key)-1);
                        $value = trim($_arr[1]); $value = substr($value, 1, strlen($value)); $value = substr($value, 0, strlen($value)-1); $value = ($value[strlen($value)-1]=="'") ? substr($value, 0, strlen($value)-1) : $value;
                        $_lang[$key] = htmlspecialchars(stripslashes($value));
                    }                    
                    $keys = ''; $hr = false;
                    foreach($correct_files[$file_name] as $k => $v) if(!isset($_lang[$k])) $keys .= "{$k}, ";
                    $keys = (strlen($keys)>2) ? substr($keys, 0, strlen($keys)-2) : $keys;                    
                    if(!empty($keys)){
                        $text .= "<span style='color: #6CCF4D;'><b>".(isset($main->lang[$correct_lang])?$main->lang[$correct_lang]:$lang_dir)." &#8594; ".(isset($main->lang[$lang_dir])?$main->lang[$lang_dir]:$lang_dir)."</b> в файле <b>{$file_name}.php</b></span><br />"; 
                        $text .= "<div style='font-family: Courier New;'><b style='float: left; margin-right: 110px;'>Недостающие ключи:</b> <div style='border: 1px #CFCFCF solid; background: #FFFFFF; padding: 0 10px 0 10px; max-height: 100px; overflow: auto; color: #BBBBBB;'>{$keys}</div></div>"; 
                        $hr = true;
                    }                    
                    $keys = '';
                    foreach($_lang as $k => $v) if(!isset($correct_files[$file_name][$k])) $keys .= "{$k}, ";
                    $keys = (strlen($keys)>2) ? substr($keys, 0, strlen($keys)-2) : $keys;
                    if(!empty($keys)){
                        $text .= "<span style='color: #EF5959;'><b>".(isset($main->lang[$lang_dir])?$main->lang[$lang_dir]:$lang_dir)." &#8594; ".(isset($main->lang[$correct_lang])?$main->lang[$correct_lang]:$lang_dir)."</b> в файле <b>{$file_name}.php</b></span><br />"; 
                        $text .= "<div style='font-family: Courier New;'><b style='float: left; margin-right: 110px;'>Недостающие ключи:</b> <div style='border: 1px #CFCFCF solid; background: #FFFFFF; padding: 0 10px 0 10px; max-height: 100px; overflow: auto; color: #BBBBBB;'>{$keys}</div></div>"; 
                        $hr = true;
                    }
                    if($hr == true) $text .= "<hr />";
                }                
            }
        }
        $text .= "</div>";
    }
} elseif($_GET['op']=='duplicate'){
    $text .= "<h2>Поиск дубликатов ключей в includes/language/{$correct_lang}/</h2><div class='warnmsg'>";
    $dup = false;
    //Игнорируем файл debugging там полюбасу дубликаты
    if(isset($correct_files['debugging'])) unset($correct_files['debugging']);    
    foreach($correct_files as $fn => $fa){
        $hr = false;
        foreach($fa as $key => $value){            
            $_temp = $correct_files; unset($_temp[$fn]); 
            foreach($_temp as $fnc => $fac) {
                if($fn=='images' OR $fnc=='images') continue;
                if(isset($_temp[$fnc][$key])) {
                    $text .= "<div style='font-family: Courier New;'><b style='color: #EF5959;'>Обнаружен дубликат:</b> `{$key}` в файле <b style='color: #333333;'>`{$fnc}.php`</b> который ранее упомянутый в файле <b style='color: #333333;'>`{$fn}.php`</b></div>";
                    $dup = true; $hr = true;
                }
            }                        
            unset($_temp);            
        }
        if($hr==true) $text .= "<hr />"; $hr = false;
    }
    if($dup==false) $text .= "<center>Дубликатов не обнаружено</center>"; 
    $text .= "</div>";
    foreach($dup_arr as $f => $a){
        if($f=='images') continue;
        $text .= "<h2>Поиск дубликатов ключей в includes/language/{$correct_lang}/{$f}.php</h2><div class='warnmsg'>";
        foreach($a as $d){
            $text .= "<div style='font-family: Courier New;'><b style='color: #EF5959;'>Обнаружен дубликат:</b> `{$d}` в файле <b style='color: #333333;'>`{$f}`</b></div>";
        }
        $text .= "</div>";
    }
}

$content = preg_replace(        
    array('/\$title/is', '/\$link/is', '/\$meta/is', '/\$content/is'), 
    array("{$main->config['home_title']} {$main->config['separator']} Проверка языковых файлов", "<link rel='stylesheet' type='text/css' href='includes/template/css/report.css' />", $tpl_create->meta_insert(), $text), 
    kr_get_content('includes/template/report.tpl')
);

echo $content;
?>